import React from 'react';
import Form from 'models/Form';
import FieldConfig from 'models/InputFieldConfig';
interface Props {
    key: string;
    form: Form;
    fields: Array<FieldConfig>;
    errors?: Array<any>;
    layout: 'grid' | 'vertical' | 'horizontal' | 'custom';
    layoutGrid?: number;
    validation?: any;
    onFormSubmit: Function;
    labelPosition?: 'left' | 'right';
    changeHandler?: Function;
    promptIfUnsaved?: true | false;
}
declare class DynamicForm extends React.PureComponent<Props, any> {
    static defaultProps: {
        layout: string;
        layoutGrid: number;
        labelPosition: string;
        key: string;
    };
    componentWillMount(): void;
    renderField(name: string, input: FieldConfig, form: any, classes: any, lClass: string, dClass: string): any;
    renderFields(inputs: Array<FieldConfig>, form: any, classes: any, lClass: string, dClass: string): any[];
    renderArray(input: FieldConfig, form: any, classes: any): any;
    renderInputNumber(name: string, input: FieldConfig, form: any, classes: any, lClass: string, dClass: string): JSX.Element;
    renderPassword(name: string, input: FieldConfig, form: any, classes: any, lClass: string, dClass: string): JSX.Element;
    renderToggle(name: string, input: FieldConfig, form: any, classes: any, lClass: string, dClass: string): JSX.Element;
    renderTextbox(name: string, input: FieldConfig, form: any, classes: any, lClass: string, dClass: string): JSX.Element;
    renderEmail(name: string, input: FieldConfig, form: any, classes: any, lClass: string, dClass: string): JSX.Element;
    renderCheckbox(name: string, input: FieldConfig, form: any, classes: any, lClass: string, dClass: string): JSX.Element;
    renderCheckboxes(name: string, input: FieldConfig, form: any, classes: any, lClass: string, dClass: string): JSX.Element;
    renderRadioButtons(name: string, input: FieldConfig, form: any, classes: any, lClass: string, dClass: string): JSX.Element;
    renderButton(name: string, input: FieldConfig, form: any, classes: any, lClass: string, dClass: string, buttonType?: 'button' | 'submit' | 'reset'): JSX.Element;
    renderDatePicker(name: string, input: FieldConfig, form: any, classes: any, lClass: string, dClass: string): JSX.Element;
    renderSelect(name: string, input: FieldConfig, form: any, classes: any, lClass: string, dClass: string): JSX.Element;
    getInitialValues(inputs: any): any;
    render(): JSX.Element;
}
export default DynamicForm;
