import React from 'react';

import { Field } from 'formik';

import InputProps from 'models/InputProps';

export default class Button extends React.Component<InputProps, any> {
  state = {
    buttonType: 'submit',
    classNames: '',
  };

  constructor(props: InputProps) {
    super(props);
    this.handleChange = this.handleChange.bind(this);
  }

  componentDidMount() {
    if (this.props.field.buttonType === 'submit') {
      this.setState({
        classNames: `btn btn-primary ${this.props.classes}`,
      });
    }
    if (this.props.field.buttonType === 'reset') {
      this.setState({
        classNames: `btn btn-secondary ${this.props.classes}`,
      });
    }
  }

  handleChange() {
    if (this.props.field.buttonType === 'reset') {
      this.props.form.handleReset();
    }
  }

  render() {
    return (
      <Field name={this.props.name}>
        {(FieldProp: any) => (
          <button
            type={this.props.field.buttonType}
            className={this.state.classNames}
            disabled={this.props.field.disabled}
            onClick={this.handleChange}
            {...FieldProp.field}
          >
            {this.props.field.label}
          </button>
        )}
      </Field>
    );
  }
}
