import React from 'react';

import { Field, ErrorMessage } from 'formik';

import InputProps from 'models/InputProps';

class Checkbox extends React.PureComponent<InputProps, any> {
  render() {
    return (
      <div className={`cb cb-primary ${this.props.classes}`}>
        <label className={this.props.lClass}></label>
        <Field type="text" name={this.props.name}>
          {(FieldProp: any) => (
            <div className={this.props.dClass}>
              <input
                name={this.props.name}
                id={this.props.name}
                type="checkbox"
                checked={this.props.form.value}
                {...FieldProp.field}
              />
              <label htmlFor={this.props.name}>{this.props.field.label}</label>
            </div>
          )}
        </Field>
        <ErrorMessage
          name={this.props.name}
          component="div"
          className="required"
        />
      </div>
    );
  }
}

export default Checkbox;
