import React from 'react';
import _ from 'lodash';

import { Field, ErrorMessage } from 'formik';

import RequiredField from './forms/RequiredField';
import InputProps from 'models/InputProps';

export default class InputText extends React.Component<InputProps, any> {
  /*
  handleChange(e: any) {
    this.props.form.setFieldValue(this.state.name, e.target.value);
    this.props.onEvent(e);
  }
  */

  render() {
    let label: any;
    let classNames: string;

    if (!this.props.field.isArrayField) {
      label = (
        <label className={this.props.lClass} htmlFor={this.props.field.id}>
          {this.props.field.label}{' '}
          {this.props.field.isRequired && <RequiredField />}
        </label>
      );
      classNames = 'form-control';
    } else {
      classNames = 'form-control';
    }

    return (
      <div className={this.props.classes} key={this.props.name}>
        {label}
        <div className={this.props.dClass}>
          <Field type="text" name={this.props.name}>
            {(FieldProp: any) => (
              <div>
                <input
                  id={this.props.name}
                  type="text"
                  {...FieldProp.field}
                  className={
                    classNames +
                    (_.get(FieldProp.form.errors, this.props.name) &&
                    _.get(FieldProp.form.touched, this.props.name)
                      ? ' is-invalid '
                      : '')
                  }
                  autoComplete="off"
                />
              </div>
            )}
          </Field>
          <ErrorMessage
            name={this.props.name}
            component="div"
            className="required"
          />
        </div>
      </div>
    );
  }
}
